//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  RoyalBlue
#property  indicator_color2  Green
#property  indicator_color3  Red
#property indicator_width2 2
#property indicator_level1 70
#property indicator_level2 50
#property indicator_level3 30
#property indicator_levelcolor DarkOliveGreen

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    RSI_Period  = 14;
extern int    RSI_Price   =  0;
extern int    RSI_shift   =  0;
extern int    MA1_Period  =  3;
extern int    MA1_Mode    =  1;
extern int    MA1_shift   =  0;
extern int    MA2_Period  =  5;
extern int    MA2_Mode    =  1;
extern int    MA2_shift   =  0;
extern bool   Interpolate = true;

//
//
//
//
//

double   RSI_Buffer[];
double   MA1_Buffer[];
double   MA2_Buffer[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;
string shortName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, RSI_Buffer);
   SetIndexBuffer(1, MA1_Buffer);
   SetIndexBuffer(2, MA2_Buffer);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame = stringToTimeFrame(TimeFrame);

      SetIndexShift(0,RSI_shift*timeFrame/Period());
      SetIndexShift(1,MA1_shift*timeFrame/Period());
      SetIndexShift(2,MA2_shift*timeFrame/Period());
   IndicatorShortName(timeFrameToString(timeFrame)+" RSI 2SigMA ("+RSI_Period+","+MA1_Period+","+MA2_Period+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { RSI_Buffer[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--) RSI_Buffer[i] = iRSI(NULL,0, RSI_Period, RSI_Price,i);
      for(i=limit; i>=0; i--) MA1_Buffer[i] = iMAOnArray(RSI_Buffer,0,MA1_Period,0,MA1_Mode,i);
      for(i=limit; i>=0; i--) MA2_Buffer[i] = iMAOnArray(MA1_Buffer,0,MA2_Period,0,MA2_Mode,i);
      return(0);
   }      

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         RSI_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Period,RSI_Price,0,MA1_Period,MA1_Mode,0,MA2_Period,MA2_Mode,0,0,y);
         MA1_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Period,RSI_Price,0,MA1_Period,MA1_Mode,0,MA2_Period,MA2_Mode,0,1,y);
         MA2_Buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Period,RSI_Price,0,MA1_Period,MA1_Mode,0,MA2_Period,MA2_Mode,0,2,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               RSI_Buffer[i+k] = RSI_Buffer[i] + (RSI_Buffer[i+n] - RSI_Buffer[i])*k/n;
               MA1_Buffer[i+k] = MA1_Buffer[i] + (MA1_Buffer[i+n] - MA1_Buffer[i])*k/n;
               MA2_Buffer[i+k] = MA2_Buffer[i] + (MA2_Buffer[i+n] - MA2_Buffer[i])*k/n;
            }                  
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}